' PALCALLS.BAS
' some special VGA palette calls

' This source-code computer programming file is Copyright, 1991 by
' Dwain Goforth.  All Rights Reserved.

' Dwain Goforth
' Milestone Software
' 1260 Sunset Ave.
' Arcata, CA 95521
' (707) 822-1291

' This software is Shareware, that is, if you decide to keep and use it
' you are required to register with the author.  Registration is $5.00.
' (If you knew how long it took me to write this code you would know why
' I am asking for $5, but I would settle for a postcard telling me you
' appreciate the program.)

' For $10, I will send the latest version as well as demo versions of
' GFONTS (over 80 QB and assembly graphic font routines)
' and VEGX (compressed and fast graphic file format for SCREEN 9
' and SCREEN 12.)

' This file will not run by itself.

' LOAD or MERGE this program into your program.

' Quicklibrary with DLGPAL is REQUIRED

' These palette routines will work ONLY in VGA SCREEN 12 mode!

DEFINT A-Z

'need for palette and VGXINT10X
TYPE RegTypeX
    ax AS INTEGER
    bx AS INTEGER
    cx AS INTEGER
    dx AS INTEGER
    bp AS INTEGER
    si AS INTEGER
    di AS INTEGER
    flags AS INTEGER
    ds AS INTEGER
    es AS INTEGER
END TYPE
DIM SHARED InRegs AS RegTypeX

' DLGPAL.LIB calls
DECLARE FUNCTION GetMemByte% (segm%, element%)  ' <-- MUST be declared!!!
DECLARE SUB SetMemByte (segm%, element%, value%)
DECLARE SUB INTRPT10X (InR AS ANY)

' VGA palette routines
DECLARE SUB GraySumCurrent ()      'gray-sums current palette
DECLARE SUB GraySumForced ()       'gray-sums using forced values
DECLARE SUB BlankPal ()            'all colors = black (watch out!)
DECLARE SUB ReadDACBLOCK (Pal%())  'get the current pallete into array
DECLARE SUB SetDACBLOCK (Pal%())   'set the current pallete using array
DECLARE SUB FadeOut ()             'fades to attribute zero
DECLARE SUB Fade2Black ()          'fades to black
DECLARE SUB RotatePalette (startpal%, EndPal%, speed%) 'rotates the palette

'DIM SHARED VGApal(0 TO 24) AS INTEGER 'you might want some SHARED
                                       'or COMMON palettes

SUB BlankPal

'makes all colors = black   (watch out!  Be sure to set colors when done.)

REDIM P(0 TO 24) AS INTEGER

InRegs.bx = 0
InRegs.cx = 16
InRegs.ax = &H1012      'set BLOCK of DAC registers
InRegs.es = VARSEG(P(0))
InRegs.dx = VARPTR(P(0))
CALL INTRPT10X(InRegs)

ERASE P

END SUB

SUB Fade2Black

' fades each palette to Black
' remember to do a CLS:PALETTE after call if wanted

REDIM BytePal(0 TO 24)
REDIM CurrentPal(0 TO 24)
REDIM SinglePal(0 TO 47) AS SINGLE
REDIM PalRatio(0 TO 47) AS SINGLE
InRegs.cx = 16

''get the current palette
InRegs.ax = &H1017      'read BLOCK of DAC registers
InRegs.es = VARSEG(CurrentPal(0))
CALL INTRPT10X(InRegs)

'calculate the stepping to get from current to final in 64 loops
FOR k = 0 TO 47
   SinglePal(k) = GetMemByte(VARSEG(CurrentPal(0)), k + 1)
   PalRatio(k) = SinglePal(k) / 64
NEXT k

'now do it!
InRegs.ax = &H1012      'set BLOCK of DAC registers
InRegs.es = VARSEG(BytePal(0))
FOR j = 1 TO 64
   FOR k = 0 TO 47
      SinglePal(k) = SinglePal(k) - PalRatio(k)
      CALL SetMemByte(VARSEG(BytePal(0)), k + 1, INT(SinglePal(k)))
   NEXT k
   CALL INTRPT10X(InRegs)
NEXT j

'give back memory
ERASE BytePal, SinglePal, CurrentPal, PalRatio

END SUB

SUB FadeIn (P%())

REDIM BytePal(0 TO 24) AS INTEGER

REDIM SinglePal(0 TO 47) AS SINGLE
REDIM PalRatio(0 TO 47) AS SINGLE

'get the current background color and put into BytePal
InRegs.ax = &H1017      'read BLOCK of DAC registers
InRegs.cx = 1
InRegs.es = VARSEG(BytePal(0))
CALL INTRPT10X(InRegs)

r = GetMemByte(VARSEG(BytePal(0)), 1)
g = GetMemByte(VARSEG(BytePal(0)), 2)
b = GetMemByte(VARSEG(BytePal(0)), 3)

FOR k = 1 TO 15
   CALL SetMemByte(VARSEG(BytePal(0)), (k * 3) + 1, r)
   CALL SetMemByte(VARSEG(BytePal(0)), (k * 3) + 2, g)
   CALL SetMemByte(VARSEG(BytePal(0)), (k * 3) + 3, b)
NEXT k

''' FADE-IN
FOR k = 0 TO 47
   r = GetMemByte(VARSEG(BytePal(0)), k + 1)
   PalRatio(k) = (GetMemByte(VARSEG(P(0)), k + 1) - r) / 64
   SinglePal(k) = r
NEXT k

InRegs.ax = &H1012      'set BLOCK of DAC registers
InRegs.es = VARSEG(BytePal(0))
InRegs.cx = 16
FOR j = 1 TO 63
   FOR k = 0 TO 47
      SinglePal(k) = SinglePal(k) + PalRatio(k)
      CALL SetMemByte(VARSEG(BytePal(0)), k + 1, INT(SinglePal(k)))
   NEXT k
   CALL INTRPT10X(InRegs)
NEXT j

'do it one last time with the original array to prevent rounding errors
InRegs.es = VARSEG(P(0))
CALL INTRPT10X(InRegs)

END SUB

SUB FadeOut

' fades each palette to 0
' remember to do a CLS:PALETTE after call if wanted

' Unfortunately, the native DOS palettes are 3-byte triplets, making it a
' pain to use integer arrays in BASIC.  GetMemByte and SetMemByte are used
' to grab one byte at a time to build arrays.

REDIM BytePal(0 TO 24)
REDIM CurrentPal(0 TO 24)

'get the current background color and put into BytePal
InRegs.ax = &H1017      'read BLOCK of DAC registers
InRegs.cx = 1
InRegs.es = VARSEG(BytePal(0))
CALL INTRPT10X(InRegs)

PalAddr = VARSEG(BytePal(0))

' get the individual red, blue and green values for attribute zero
r = GetMemByte(PalAddr, 1)
g = GetMemByte(PalAddr, 2)
b = GetMemByte(PalAddr, 3)

'set all the BytePal values to the same as attribute zero
FOR k = 1 TO 15
   CALL SetMemByte(PalAddr, (k * 3) + 1, r)
   CALL SetMemByte(PalAddr, (k * 3) + 2, g)
   CALL SetMemByte(PalAddr, (k * 3) + 3, b)
NEXT k

REDIM SinglePal(0 TO 47) AS SINGLE
REDIM PalRatio(0 TO 47) AS SINGLE

InRegs.cx = 16

''get the current palette
InRegs.ax = &H1017      'read BLOCK of DAC registers
InRegs.es = VARSEG(CurrentPal(0))
CALL INTRPT10X(InRegs)

'calculate stepping to get from current to attribute zero
FOR k = 0 TO 47
   SinglePal(k) = GetMemByte(VARSEG(CurrentPal(0)), k + 1)
   PalRatio(k) = (SinglePal(k) - GetMemByte(VARSEG(BytePal(0)), k + 1)) / 64
NEXT k

'Now do it!
InRegs.ax = &H1012      'set BLOCK of DAC registers
InRegs.es = VARSEG(BytePal(0))
FOR j = 1 TO 64
   FOR k = 0 TO 47
      SinglePal(k) = SinglePal(k) - PalRatio(k)
      CALL SetMemByte(VARSEG(BytePal(0)), k + 1, INT(SinglePal(k)))
   NEXT k
   CALL INTRPT10X(InRegs)
NEXT j

ERASE BytePal, SinglePal, CurrentPal, PalRatio

END SUB

SUB GraySumCurrent

'''gray-scale summing using current values

InRegs.bx = 0
InRegs.ax = &H101B
InRegs.cx = 16
CALL INTRPT10X(InRegs)

END SUB

SUB GraySumForced

'forced gray scale summing
'Does not use current values, but forces 0 as black and 15 as white

cx = 0
dx = 0
FOR k = 0 TO 15
   InRegs.bx = k
   InRegs.ax = &H1010  'set individual DAC register
   InRegs.dx = dx
   InRegs.cx = cx
   cx = cx + &H404
   dx = dx + &H400
   CALL INTRPT10X(InRegs)
NEXT k

END SUB

SUB ReadDACBLOCK (CurrPal%())

'''save current palette into array

InRegs.bx = 0
InRegs.ax = &H1017      'read BLOCK of DAC registers
InRegs.cx = 16
InRegs.es = VARSEG(CurrPal(0))
InRegs.dx = VARPTR(CurrPal(0))
CALL INTRPT10X(InRegs)

END SUB

SUB RotatePalette (startpal%, EndPal%, Rdelay%)

'startpal is first attribute to rotate
'endpal is last attribute to rotate
'rdelay is time to pause

REDIM RotatePal(0 TO 72)  AS INTEGER    'room for 3 sets of 24-byte palettes
PalCount = EndPal% - startpal% + 1

FOR k = 0 TO 2
   'save current palette into array in 3 blocks so we can rotate smoothly
   InRegs.bx = 0
   InRegs.ax = &H1017              'read BLOCK of DAC registers
   InRegs.cx = 16
   InRegs.es = VARSEG(RotatePal(0))
   InRegs.dx = VARPTR(RotatePal(k * 24))
   CALL INTRPT10X(InRegs)
'  RotatePal(k * 24) = &H9999
NEXT k

InRegs.ax = &H1012      'set BLOCK of DAC registers
InRegs.bx = startpal%
InRegs.cx = PalCount
InRegs.es = VARSEG(RotatePal(0))

DO
   FOR k% = startpal + 15 TO startpal STEP -1
      IF INKEY$ <> "" THEN GOTO RPbye
      InRegs.dx = VARPTR(RotatePal(k%)) + k%
      CALL INTRPT10X(InRegs)
      T1! = TIMER
      T2! = T1! + Rdelay / 1000
      WHILE T2! > TIMER: WEND
   NEXT k%
LOOP

RPbye:

'one last time to leave it where we started
InRegs.bx = 0
InRegs.cx = 16
RotatePal(0) = 0
InRegs.dx = VARPTR(RotatePal(0))
CALL INTRPT10X(InRegs)

ERASE RotatePal

END SUB

SUB SetDACBLOCK (P%())

'put array into palette memory

InRegs.ax = &H1012      'set BLOCK of DAC registers
InRegs.bx = 0
InRegs.cx = 16
InRegs.es = VARSEG(P(0))
InRegs.dx = VARPTR(P(0))
CALL INTRPT10X(InRegs)

END SUB

