' PALDEMO.BAS, 12/91

' Demo of routines found in PALCALLS.BAS

' Quicklibrary with DLGPAL is REQUIRED

' LOAD or MERGE PALCALLS.BAS into this program.

' These palette routines will work ONLY in VGA SCREEN 12 mode!

' This source-code computer programming file is Copyright, 1991 by
' Dwain Goforth.  All Rights Reserved.

' Dwain Goforth
' Milestone Software
' 1260 Sunset Ave.
' Arcata, CA 95521
' (707) 822-1291

' This software is Shareware, that is, if you decide to keep and use it
' you are required to register with the author.  Registration is $5.00.
' (If you knew how long it took me to write this code you would know why
' I am asking for $5, but I would settle for a postcard telling me you
' appreciate the program.)

' For $10, I will send the latest version as well as demo versions of
' GFONTS (over 80 QB and assembly graphic font routines)
' and VEGX (compressed and fast graphic file format for SCREEN 9
' and SCREEN 12.)

DEFINT A-Z

DECLARE SUB GraySumCurrent ()      'gray-sums current palette
DECLARE SUB GraySumForced ()       'gray-sums using forced values
DECLARE SUB BlankPal ()            'all colors = black (watch out!)
DECLARE SUB ReadDACBLOCK (Pal%())  'get the current pallete into array
DECLARE SUB SetDACBLOCK (Pal%())   'set the current pallete using array
DECLARE SUB FadeIn (P%())
DECLARE SUB FadeOut ()             'fades to attribute zero
DECLARE SUB Fade2Black ()          'fades to black
DECLARE SUB RotatePalette (startpal%, endpal%, speed%) 'rotates the palette

DECLARE SUB Pausex (seconds!)

DIM VGAPal(0 TO 23) AS INTEGER
' dimension a palette array to hold 48 bytes (you might want SHARED or
' COMMON palette arrays.)

'''''''''''''''
SCREEN 12

y = 20
kolor = 0
FOR x = 0 TO 600 STEP 40
   LINE (x, y)-(x + 36, y + 72), kolor, BF
   kolor = kolor + 1
NEXT x

' First, let's load the current palette into VGApal
' so we can restore it later.
CALL ReadDACBLOCK(VGAPal())   'get the current pallete into array

LOCATE 8, 1
COLOR 1
PRINT "First we will blank the palette.  All colors will equal zero but the"
PRINT "screen data will remain.  Hit a key to blank, THEN HIT A KEY AGAIN..."
DO: LOOP WHILE INKEY$ = ""

CALL BlankPal
' BE CAREFUL using BlankPal because the screen will STAY black until you
' restore some colors.

DO: LOOP WHILE INKEY$ = ""
CALL SetDACBLOCK(VGAPal())   'set the palette we stored above

COLOR 2: PRINT "Hit a key to continue..."
DO: LOOP WHILE INKEY$ = ""

PALETTE 0, 30
CALL ReadDACBLOCK(VGAPal())   'get the current pallete into array

COLOR 3
PRINT "We have used PALETTE 0,30 to change the background color."
PRINT "Now we will FADE to the BACKGROUND color and then fade back."
PRINT "Hit a key to begin..."
DO: LOOP WHILE INKEY$ = ""

CALL FadeOut
CALL Pausex(1)
CALL FadeIn(VGAPal())

PALETTE 4, 54
COLOR 4
PRINT "We will now fade to BLACK no matter what the background color is."
PRINT "Hit a key to begin..."
DO: LOOP WHILE INKEY$ = ""

CALL Fade2Black
CALL Pausex(1)
CALL FadeIn(VGAPal())

COLOR 5: PRINT "Hit a key to continue..."
DO: LOOP WHILE INKEY$ = ""
PALETTE 0, 0
CALL ReadDACBLOCK(VGAPal())   'get the current pallete into array

COLOR 6
PRINT "We will now ROTATE the palette in all colors."
PRINT "Hit a key to begin then hit a key AGAIN to FINISH..."
DO: LOOP WHILE INKEY$ = ""

startpal% = 0: endpal% = 15: speed% = 450
CALL RotatePalette(startpal%, endpal%, speed%)  'rotates the palette

COLOR 7: PRINT "We can go faster...and just rotate part of the pallete"
startpal% = 4: endpal% = 13: speed% = 120
CALL RotatePalette(startpal%, endpal%, speed%)  'rotates the palette

COLOR 8: PRINT "We can go faster still!!!";
startpal% = 3: endpal% = 13: speed% = 0
CALL RotatePalette(startpal%, endpal%, speed%)  'rotates the palette

' Next we will show the gray values...
COLOR 9
PRINT "Hit any key to show the Gray-sum version of the current palette..."
DO: LOOP WHILE INKEY$ = ""

CALL GraySumCurrent

'restore the VGApal array palette
COLOR 10
PRINT "Hit any key to restore the palette..."
DO: LOOP WHILE INKEY$ = ""

CALL SetDACBLOCK(VGAPal())   'set the palette with array

' Next we will show the FORCED gray values...
COLOR 11
PRINT "Hit any key to show the FORCED Gray-sum version of the current palette..."
DO: LOOP WHILE INKEY$ = ""

CALL GraySumForced

DO: LOOP WHILE INKEY$ = ""
PALETTE 15, 63
COLOR 15
LOCATE 24, 1
PRINT "This has been a demo of PALCALLS by Milestone Software..."

LINE (1, 1)-(639, 100), 0, BF

startpal% = 1: endpal% = 14: speed% = 50
CALL RotatePalette(startpal%, endpal%, speed%)  'rotates the palette

FadeOut

CLS
PALETTE
SCREEN 0
END

SUB Pausex (seconds!)

t2! = TIMER + seconds!
DO: LOOP UNTIL TIMER > t2!

END SUB

